(*C*
      Embedding UNITY into the Calculus of Inductive Constructions
                                     Using the COQ Proof Assistent
      Author:  Mark-Oliver Stehr
               University of Hamburg
               Department of Computer Science
               Theoretical Foundations of Computer Science Group 
               stehr@informatik.uni-hamburg.de
      Date:    September 1998
*C*)




Load unity_init. 


Variable u_var:Set. 


Variable u_vars : nat. 
Variable u_ith_var : nat->u_var.


Hypothesis u_var_finite : (v:u_var)
  (Ex [i:nat] (lt i u_vars) /\ (u_ith_var i)=v).


Hypothesis u_var_eq_dec:(v,v':u_var){(v=v')}+{~(v=v')}.


Variable u_type_name:Set.


Hypothesis u_type_name_eq_dec:(n,n':u_type_name){(n=n')}+{~(n=n')}.


Variable u_type:u_type_name->Set.


Variable u_var_type_name:u_var->u_type_name.


Load unity_states. 


Variable u_tr:Set.


Hypothesis u_tr_eq_dec:(t,t':u_tr){(t=t')}+{~(t=t')}.


Variable u_effect : u_tr->u_st->u_st.



Load unity_program.


Load unity_logic. 


Load unity_depend. 


Load unity_safety.


Load unity_liveness.


Load unity_union.


















